/* This file is part of flowz.
   Copyright (C) 2006 Sergey Poznyakoff

   Flowz is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   Flowz is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with flowz; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
   MA 02110-1301 USA */

#include "flowz.h"

int
level_1(char **toks, size_t ntoks)
{
     time_t timestamp;
     uintmax_t octets, n;
     char *p;
     static unsigned char keymap[] = { 2, 3, 4, 5, 6, 7, 8, 9, 10 };
     
     timestamp = n = strtoumax(toks[0], &p, 0);
     if (*p) {
	  error(0, 0, "%s:%lu: cannot convert timestamp (near %s)",
		input, (unsigned long) lineno, p);
	  return 1;
     } else if (n != timestamp || errno == ERANGE) {
	  error(0, 0,
		"%s:%lu: cannot convert timestamp (out of allowed range)",
		input, (unsigned long) lineno, p);
	  return 1;
     }
     
     octets = strtoumax(toks[1], &p, 0);
     if (*p) {
	  error(0, 0, "%s:%lu: cannot convert octets (near %s)",
		input, (unsigned long) lineno, p);
	  return 1;
     } else if (errno == ERANGE) {
	  error(0, 0, "%s:%lu: cannot convert octets (out of allowed range)",
		input, (unsigned long) lineno);
	  return 1;
     }
     
     if (update(make_key(keymap, sizeof keymap/sizeof keymap[0], toks),
		timestamp, timestamp, octets))
	  error(0, 0, "integer overflow");
     return 0;
}

